Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.trolltech.qt.gui
Class QSpinBox

    java.lang.Object
      com.trolltech.qt.internal.QSignalEmitterInternal
          com.trolltech.qt.QSignalEmitter
              com.trolltech.qt.QtJambiObject
                  com.trolltech.qt.core.QObject
                      com.trolltech.qt.gui.QWidget
                          com.trolltech.qt.gui.QAbstractSpinBox
                              com.trolltech.qt.gui.QSpinBox

All Implemented Interfaces:
  QPaintDeviceInterface, QtJambiInterface

    public class QSpinBox

extends QAbstractSpinBox

The QSpinBox class provides a spin box widget. QSpinBox is designed to handle integers and discrete sets of values (e.g., month names); use `QDoubleSpinBox` for floating point values.

QSpinBox allows the user to choose a value by clicking the up/down buttons or pressing up/down on the keyboard to increase/decrease the value currently displayed. The user can also type the value in manually. The spin box supports integer values but can be extended to use different strings with `validate()`, `textFromValue()` and `valueFromText()`.

Every time the value changes QSpinBox emits the `valueChanged()` signals. The current value can be fetched with `value()` and set with `setValue()`.

Clicking the up/down buttons or using the keyboard accelerator's up and down arrows will increase or decrease the current value in steps of size `singleStep()`. If you want to change this behaviour you can reimplement the virtual function `stepBy()`. The minimum and maximum value and the step size can be set using one of the constructors, and can be changed later with `setMinimum()`, `setMaximum()` and `setSingleStep()`.

Most spin boxes are directional, but QSpinBox can also operate as a circular spin box, i.e. if the range is 0-99 and the current value is 99, clicking "up" will give 0 if wrapping() is set to true. Use setWrapping() if you want circular behavior.

The displayed value can be prepended and appended with arbitrary strings indicating, for example, currency or the unit of measurement. See `setPrefix()` and `setSuffix()`. The text in the spin box is retrieved with text() (which includes any `prefix()` and `suffix()`), or with `cleanText()` (which has no `prefix()`, no `suffix()` and no leading or trailing whitespace).

It is often desirable to give the user a special (often default) choice in addition to the range of numeric values. See setSpecialValueText() for how to do this with QSpinBox.

| A spin box shown in the Windows XP widget style.
| A spin box shown in the Plastique widget style.
| A spin box shown in the Macintosh widget style.

## Subclassing QSpinBox

If using `prefix()`, `suffix()`, and specialValueText() don't provide enough control, you subclass QSpinBox and reimplement `valueFromText()` and `textFromValue()`. For example, here's the code for a custom spin box that allows the user to enter icon sizes (e.g., "32 x 32"):
The following code example is written in c++.

    int IconSizeSpinBox::valueFromText(const QString &text) const
    {
        QRegExp regExp(tr("(\\d+)(\\s*[xx]\\s\*\d+)?"));

        if (regExp.exactMatch(text)) {
            return regExp.cap(1).toInt();
        } else {
            return 0;
        }
    }

    QString IconSizeSpinBox::textFromValue(int value) const
    {
        return tr("%1 x %1").arg(value);
    }

See the Icons example for the full source code.

See also:
  `QDoubleSpinBox`, `QDateTimeEdit`, `QSlider`, and Spin Boxes Example.

Nested Class Summary

Nested classes/interfaces inherited from class com.trolltech.qt.gui.QAbstractSpinBox
`QAbstractSpinBox.ButtonSymbols, QAbstractSpinBox.CorrectionMode, QAbstractSpinBox.StepEnabled, QAbstractSpinBox.StepEnabledFlag`

Nested classes/interfaces inherited from class com.trolltech.qt.gui.QWidget
`QWidget.RenderFlag, QWidget.RenderFlags`

Nested classes/interfaces inherited from class com.trolltech.qt.QSignalEmitter
`QSignalEmitter.AbstractSignal, QSignalEmitter.Signal0, QSignalEmitter.Signal1, QSignalEmitter.Signal2, QSignalEmitter.Signal3, QSignalEmitter.Signal4, QSignalEmitter.Signal5, QSignalEmitter.Signal6, QSignalEmitter.Signal7, QSignalEmitter.Signal8, QSignalEmitter.Signal9`

Nested classes/interfaces inherited from class com.trolltech.qt.internal.QSignalEmitterInternal
`com.trolltech.qt.internal.QSignalEmitterInternal.AbstractSignalInternal`

Field Summary
`QSignalEmitter.Signal1` | `valueChanged` This signal takes 1 generic argument(s).
`QSignalEmitter.Signal1` | `valueStringChanged` This signal takes 1 generic argument(s).

Fields inherited from class com.trolltech.qt.gui.QAbstractSpinBox
`editingFinished`

Fields inherited from class com.trolltech.qt.gui.QWidget
`customContextMenuRequested`

Fields inherited from class com.trolltech.qt.internal.QSignalEmitterInternal
`currentSender`

Constructor Summary
`QSpinBox()` Constructs a spin box with 0 as minimum value and 99 as maximum value, a step value of 1.
`QSpinBox(QWidget parent)` Constructs a spin box with 0 as minimum value and 99 as maximum value, a step value of 1.

Method Summary
`java.lang.String` | `cleanText()` This property holds the text of the spin box excluding any prefix, suffix, or leading or trailing whitespace.
`int` | `maximum()` This property holds the maximum value of the spin box.
`int` | `minimum()` This property holds the minimum value of the spin box.
`java.lang.String` | `prefix()` This property holds the spin box's prefix.
`void` | `setMaximum(int max)` This property holds the maximum value of the spin box.
`void` | `setMinimum(int min)` This property holds the minimum value of the spin box.
`void` | `setPrefix(java.lang.String prefix)` This property holds the spin box's prefix.
`void` | `setRange(int min, int max)` Convenience function to set the `minimum`, and `maximum` values with a single function call.
`void` | `setSingleStep(int val)` This property holds the step value.
`void` | `setSuffix(java.lang.String suffix)` This property holds the suffix of the spin box.
`void` | `setValue(int val)` This property holds the value of the spin box.
`int` | `singleStep()` This property holds the step value.
`java.lang.String` | `suffix()` This property holds the suffix of the spin box.
`protected java.lang.String` | `textFromValue(int val)` This virtual function is used by the spin box whenever it needs to display the given `value`.
`int` | `value()` This property holds the value of the spin box.
`protected int` | `valueFromText(java.lang.String text)` This virtual function is used by the spin box whenever it needs to interpret `text` entered by the user as a value.

Methods inherited from class com.trolltech.qt.gui.QAbstractSpinBox
`alignment, buttonSymbols, clear, correctionMode, fixup, hasAcceptableInput, hasFrame, initStyleOption, interpretText, isAccelerated, isReadOnly, keyboardTracking, lineEdit, selectAll, setAccelerated, setAlignment, setAlignment, setButtonSymbols, setCorrectionMode, setFrame, setKeyboardTracking, setLineEdit, setReadOnly, setSpecialValueText, setWrapping, specialValueText, stepBy, stepDown, stepEnabled, stepUp, text, validate, wrapping`

Methods inherited from class com.trolltech.qt.gui.QWidget
`acceptDrops, accessibleDescription, accessibleName, actionEvent, actions, activateWindow, addAction, addActions, adjustSize, autoFillBackground, backgroundRole, baseSize, changeEvent, childAt, childAt, childrenRect, childrenRegion, clearFocus, clearMask, close, closeEvent, contentsRect, contextMenuEvent, contextMenuPolicy, cursor, depth, destroy, destroy, destroy, dragEnterEvent, dragLeaveEvent, dragMoveEvent, dropEvent, effectiveWinId, ensurePolished, enterEvent, focusInEvent, focusNextChild, focusNextPrevChild, focusOutEvent, focusPolicy, focusPreviousChild, focusProxy, focusWidget, font, fontInfo, fontMetrics, foregroundRole, frameGeometry, frameSize, geometry, getContentsMargins, grabKeyboard, grabMouse, grabMouse, grabShortcut, grabShortcut, hasFocus, hasMouseTracking, height, heightForWidth, heightMM, hide, hideEvent, inputContext, inputMethodEvent, inputMethodQuery, insertAction, insertActions, isActiveWindow, isAncestorOf, isEnabled, isEnabledTo, isFullScreen, isHidden, isMaximized, isMinimized, isModal, isVisible, isVisibleTo, isWindow, isWindowModified, keyboardGrabber, keyPressEvent, keyReleaseEvent, languageChange, layout, layoutDirection, leaveEvent, locale, logicalDpiX, logicalDpiY, lower, mapFrom, mapFromGlobal, mapFromParent, mapTo, mapToGlobal, mapToParent, mask, maximumHeight, maximumSize, maximumWidth, metric, minimumHeight, minimumSize, minimumSizeHint, minimumWidth, mouseDoubleClickEvent, mouseGrabber, mouseMoveEvent, mousePressEvent, mouseReleaseEvent, move, move, moveEvent, nativeParentWidget, nextInFocusChain, normalGeometry, numColors, overrideWindowFlags, overrideWindowFlags, overrideWindowState, paintEngine, paintEvent, paintingActive, palette, parentWidget, physicalDpiX, physicalDpiY, pos, raise, rect, releaseKeyboard, releaseMouse, releaseShortcut, removeAction, render, render, render, render, render, render, render, render, render, repaint, repaint, repaint, repaint, resetInputContext, resize, resize, resizeEvent, restoreGeometry, saveGeometry, scroll, scroll, setAcceptDrops, setAccessibleDescription, setAccessibleName, setAttribute, setAttribute, setAutoFillBackground, setBackgroundRole, setBaseSize, setBaseSize, setContentsMargins, setContentsMargins, setContextMenuPolicy, setCursor, setDisabled, setEnabled, setFixedHeight, setFixedSize, setFixedSize, setFixedWidth, setFocus, setFocus, setFocusPolicy, setFocusProxy, setFont, setForegroundRole, setGeometry, setGeometry, setHidden, setInputContext, setLayout, setLayoutDirection, setLocale, setMask, setMask, setMaximumHeight, setMaximumSize, setMaximumSize, setMaximumWidth, setMinimumHeight, setMinimumSize, setMinimumSize, setMinimumWidth, setMouseTracking, setPalette, setParent, setParent, setParent, setShortcutAutoRepeat, setShortcutAutoRepeat, setShortcutEnabled, setShortcutEnabled, setSizeIncrement, setSizeIncrement, setSizePolicy, setSizePolicy, setStatusTip, setStyle, setStyleSheet, setTabOrder, setToolTip, setUpdatesEnabled, setVisible, setWhatsThis, setWindowFilePath, setWindowFlags, setWindowFlags, setWindowIcon, setWindowIconText, setWindowModality, setWindowModified, setWindowOpacity, setWindowRole, setWindowState, setWindowState, setWindowTitle, show, showEvent, showFullScreen, showMaximized, showMinimized, showNormal, size, sizeHint, sizeIncrement, sizePolicy, stackUnder, statusTip, style, styleSheet, tabletEvent, testAttribute, toolTip, underMouse, unsetCursor, unsetLayoutDirection, unsetLocale, update, update, update, update, updateGeometry, updateMicroFocus, updatesEnabled, visibleRegion, whatsThis, wheelEvent, width, widthMM, window, windowFilePath, windowFlags, windowIcon, windowIconText, windowModality, windowOpacity, windowRole, windowState, windowTitle, windowType, winId, x, y`

Methods inherited from class com.trolltech.qt.core.QObject
`childEvent, children, connectSlotsByName, customEvent, disposeLater, dumpObjectInfo, dumpObjectTree, dynamicPropertyNames, event, eventFilter, findChild, findChild, findChild, findChildren, findChildren, findChildren, findChildren, indexOfProperty, installEventFilter, isWidgetType, killTimer, moveToThread, objectName, parent, properties, property, removeEventFilter, setObjectName, setParent, setProperty, startTimer, timerEvent, toString, userProperty`

Methods inherited from class com.trolltech.qt.QtJambiObject
`dispose, disposed, equals, finalize, reassignNativeResources, tr, tr, tr`

Methods inherited from class com.trolltech.qt.QSignalEmitter
`blockSignals, disconnect, disconnect, signalsBlocked, signalSender, thread`

Methods inherited from class com.trolltech.qt.internal.QSignalEmitterInternal
`__qt_signalInitialization`

Methods inherited from class java.lang.Object
`clone, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Methods inherited from interface com.trolltech.qt.QtJambiInterface
`disableGarbageCollection, nativeId, nativePointer, reenableGarbageCollection, setJavaOwnership`

Field Detail

### valueStringChanged

    public final QSignalEmitter.Signal1 valueStringChanged

  This signal takes 1 generic argument(s). We list their type and the name they go by in the description of this signal. <java.lang.String(named: arg__1)>:

### valueChanged

    public final QSignalEmitter.Signal1 valueChanged

  This signal takes 1 generic argument(s). We list their type and the name they go by in the description of this signal. <java.lang.Integer(named: i)>:

  This signal is emitted whenever the spin box's value is changed. The new value's integer value is passed in `i`.

Constructor Detail

### QSpinBox

    public QSpinBox()

  Constructs a spin box with 0 as minimum value and 99 as maximum value, a step value of 1. The value is initially set to 0. It is parented to `parent`.

See also:
  `setMinimum()`, `setMaximum()`, and `setSingleStep()`.

### QSpinBox

    public QSpinBox(QWidget parent)

  Constructs a spin box with 0 as minimum value and 99 as maximum value, a step value of 1. The value is initially set to 0. It is parented to `parent`.

See also:
  `setMinimum()`, `setMaximum()`, and `setSingleStep()`.

Method Detail

### cleanText

    public final java.lang.String cleanText()

  This property holds the text of the spin box excluding any prefix, suffix, or leading or trailing whitespace.

See also:
  `text`, `QSpinBox::prefix`, and `QSpinBox::suffix`.

### maximum

    public final int maximum()

  This property holds the maximum value of the spin box. When setting this property the `minimum` is adjusted if necessary, to ensure that the range remains valid.

  The default maximum value is 99.

See also:
  `setRange()`, and `specialValueText`.

### minimum

    public final int minimum()

  This property holds the minimum value of the spin box. When setting this property the `maximum` is adjusted if necessary to ensure that the range remains valid.

  The default minimum value is 0.

See also:
  `setRange()`, and `specialValueText`.

### prefix

    public final java.lang.String prefix()

  This property holds the spin box's prefix. The prefix is prepended to the start of the displayed value. Typical use is to display a unit of measurement or a currency symbol. For example:

              spinbox.setPrefix("$");

  To turn off the prefix display, set this property to an empty string. The default is no prefix. The prefix is not displayed when `value()` == `minimum()` and specialValueText() is set.

  If no prefix is set, `prefix()` returns an empty string.

See also:
  `suffix()`, `setSuffix()`, specialValueText(), and setSpecialValueText().

### setMaximum

    public final void setMaximum(int max)

  This property holds the maximum value of the spin box. When setting this property the `minimum` is adjusted if necessary, to ensure that the range remains valid.

  The default maximum value is 99.

See also:
  `setRange()`, and `specialValueText`.

### setMinimum

    public final void setMinimum(int min)

  This property holds the minimum value of the spin box. When setting this property the `maximum` is adjusted if necessary to ensure that the range remains valid.

  The default minimum value is 0.

See also:
  `setRange()`, and `specialValueText`.

### setPrefix

    public final void setPrefix(java.lang.String prefix)

  This property holds the spin box's prefix. The prefix is prepended to the start of the displayed value. Typical use is to display a unit of measurement or a currency symbol. For example:

              spinbox.setPrefix("$");

  To turn off the prefix display, set this property to an empty string. The default is no prefix. The prefix is not displayed when `value()` == `minimum()` and specialValueText() is set.

  If no prefix is set, `prefix()` returns an empty string.

See also:
  `suffix()`, `setSuffix()`, specialValueText(), and setSpecialValueText().

### setRange

    public final void setRange(int min,
                               int max)

  Convenience function to set the `minimum`, and `maximum` values with a single function call.

              spinbox.setRange(minimum, maximum);

  is equivalent to:

              spinbox.setMinimum(minimum);
              spinbox.setMaximum(maximum);

See also:
  `minimum`, and `maximum`.

### setSingleStep

    public final void setSingleStep(int val)

  This property holds the step value. When the user uses the arrows to change the spin box's value the value will be incremented/decremented by the amount of the `singleStep`. The default value is 1. Setting a `singleStep` value of less than 0 does nothing.

### setSuffix

    public final void setSuffix(java.lang.String suffix)

  This property holds the suffix of the spin box. The suffix is appended to the end of the displayed value. Typical use is to display a unit of measurement or a currency symbol. For example:

              spinbox.setSuffix(" km");

  To turn off the suffix display, set this property to an empty string. The default is no suffix. The suffix is not displayed for the `minimum()` if specialValueText() is set.

  If no suffix is set, `suffix()` returns an empty string.

See also:
  `prefix()`, `setPrefix()`, specialValueText(), and setSpecialValueText().

### setValue

    public final void setValue(int val)

  This property holds the value of the spin box. `setValue()` will emit `valueChanged()` if the new value is different from the old one.

### singleStep

    public final int singleStep()

  This property holds the step value. When the user uses the arrows to change the spin box's value the value will be incremented/decremented by the amount of the `singleStep`. The default value is 1. Setting a `singleStep` value of less than 0 does nothing.

### suffix

    public final java.lang.String suffix()

  This property holds the suffix of the spin box. The suffix is appended to the end of the displayed value. Typical use is to display a unit of measurement or a currency symbol. For example:

              spinbox.setSuffix(" km");

  To turn off the suffix display, set this property to an empty string. The default is no suffix. The suffix is not displayed for the `minimum()` if specialValueText() is set.

  If no suffix is set, `suffix()` returns an empty string.

See also:
  `prefix()`, `setPrefix()`, specialValueText(), and setSpecialValueText().

### value

    public final int value()

  This property holds the value of the spin box. `setValue()` will emit `valueChanged()` if the new value is different from the old one.

### textFromValue

    protected java.lang.String textFromValue(int val)

  This virtual function is used by the spin box whenever it needs to display the given `value`. The default implementation returns a string containing `value` printed in the standard way using `QWidget::locale()`.toString(). Reimplementations may return anything. (See the example in the detailed description.)

  Note: QSpinBox does not call this function for specialValueText() and that neither `prefix()` nor `suffix()` should be included in the return value.

  If you reimplement this, you may also need to reimplement `valueFromText()` and `validate()`

See also:
  `valueFromText()`, and `validate()`.

### valueFromText

    protected int valueFromText(java.lang.String text)

  This virtual function is used by the spin box whenever it needs to interpret `text` entered by the user as a value.

  Subclasses that need to display spin box values in a non-numeric way need to reimplement this function.

  Note: QSpinBox handles specialValueText() separately; this function is only concerned with the other values.

See also:
  `textFromValue()`, and `validate()`.

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD